#line 1 "F:/MikroC/RacingLights/RaceLights.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 1 "f:/mikroc/racinglights/types.h"
#line 14 "f:/mikroc/racinglights/types.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;
#line 31 "F:/MikroC/RacingLights/RaceLights.c"
static volatile boolean blnTimerExpired;
static volatile boolean blnRunning;
static int intStep, intOutCount;
#line 37 "F:/MikroC/RacingLights/RaceLights.c"
void interrupt(void) {
 TMR0H = 0x48;
 TMR0L = 0xE5;
 TMR0IF_bit = 0;

 if ( blnRunning == TRUE && blnTimerExpired == FALSE ) {
 blnTimerExpired = TRUE;
 }
}
#line 49 "F:/MikroC/RacingLights/RaceLights.c"
void resetLights(void) {

 blnRunning = blnTimerExpired = FALSE;

 intStep = 0;

 LATB = 0;
}
#line 60 "F:/MikroC/RacingLights/RaceLights.c"
void main(void) {


 ANSELA = 0;
 ANSELB = 0;
#line 69 "F:/MikroC/RacingLights/RaceLights.c"
 TRISA = 0xff;
 TRISB = 0;
 LATB = 0;

 resetLights();



 T0CON.TMR0ON = 1;
 T0CON.T08BIT = 0;
 T0CON.T0CS = 0;
 T0CON.T0SE = 0;
 T0CON.PSA = 0;
 T0CON.T0PS2 = 1;
 T0CON.T0PS1 = 0;
 T0CON.T0PS0 = 0;
 TMR0H = 0x48;
 TMR0L = 0xE5;
 TMR0IE_bit = 1;

 GIE_bit = 1;

 while( 1 ) {
 if ( blnRunning == TRUE ) {
 if ( Button(&PORTA,  1 ,  20 , 1) ) {
 blnRunning = FALSE;
 LATB |=  0x40 ;
 } else if ( blnTimerExpired == TRUE ) {
 switch( intStep ) {
 case 0:
 LATB |=  0x01 ;
 break;
 case 1:
 LATB |=  0x02 ;
 break;
 case 2:
 LATB |=  0x04 ;
 break;
 case 3:
 LATB |=  0x08 ;
 break;
 case 4:
 LATB |=  0x10 ;

 intOutCount = rand() % (7 - 3) + 3;
 break;
 case 5:
 if ( --intOutCount == 0 ) {
 resetLights();
 LATB |=  0x20 ;
 }
 break;
 }
 if ( (LATB &  0x20 ) !=  0x20  && intStep < 5 ) {
 intStep++;
 }

 blnTimerExpired = FALSE;
 }
 } else if ( (LATB &  0x20 ) !=  0x20  &&
 Button(&PORTA,  0 ,  20 , 1) ) {
 blnRunning = TRUE;
 } else if ( Button(&PORTA,  2 ,  20 , 1) ) {
 resetLights();
 }
 }
}
